package proc;

import java.util.ArrayList;

public class Transition {
	public String label;
	public String channel;
	public boolean output;
	public ArrayList<ProbOfProc> dist;
	
	public Transition(String label, String channel, boolean output, ArrayList<ProbOfProc> dist) {
		this.label = label;
		this.channel = channel;
		this.output = output;
		this.dist = dist;
	}
	
	public static Transition dirac (String label, String channel, boolean output, Proc p) {
		ArrayList<ProbOfProc>dist = new ArrayList<ProbOfProc>();
		dist.add(new ProbOfProc(1, p));
		return new Transition(label, channel, output, dist);
	}
	
	public Transition clone() {
		ArrayList<ProbOfProc> newdist = new ArrayList<ProbOfProc>();
		for(ProbOfProc p : dist)
			newdist.add(new ProbOfProc(p));
		
		return new Transition(label, channel, output, newdist);
	}
	
	public String toString() {
		return label + ":" + (output ? "#" : "") + channel + " -> " +	dist;
	}
	
	public String actionString() {
		return label + ":" + (output ? "#" : "") + channel;
	}
}
